package MovementStrategy;


public interface IMoveableObject {
    /// <summary>
    /// Получение координаты X объекта
    /// </summary>
    public ObjectParameters GetObjectPosition();
    /// <summary>
    /// Шаг объекта
    /// </summary>
    public int GetStep();

    boolean CheckCanMove(Direction direction);
    /// <summary>
    /// Изменение направления пермещения объекта
    /// </summary>
    /// <param name="direction">Направление</param>
    void MoveObject(Direction direction);
}

